#include "OpenCLErrorHandler.h"
#include <stdio.h>

//  Fehlerbehandlungsroutine

int checkError(cl_int errCode) {
	const char *fmtString = "%s\n";
	switch (errCode) {
		case CL_SUCCESS:
		break;
		case CL_INVALID_PROGRAM_EXECUTABLE:
		  printf(fmtString, "CL_INVALID_PROGRAM_EXECUTABLE");
		break;
		case CL_INVALID_COMMAND_QUEUE:
		  printf(fmtString, "CL_INVALID_COMMAND_QUEUE");
		break;
		case CL_INVALID_KERNEL:
		  printf(fmtString, "CL_INVALID_KERNEL");
		break;
		case CL_INVALID_CONTEXT:
		  printf(fmtString, "CL_INVALID_CONTEXT");
		break;
		case CL_INVALID_KERNEL_ARGS:
		  printf(fmtString, "CL_INVALID_KERNEL_ARGS");
		break;
		case CL_INVALID_WORK_DIMENSION:
		  printf(fmtString, "CL_INVALID_WORK_DIMENSION");
		break;
		case CL_INVALID_WORK_GROUP_SIZE:
		  printf(fmtString, "CL_INVALID_WORK_GROUP_SIZE");
		break;
		case CL_INVALID_WORK_ITEM_SIZE:
		  printf(fmtString, "CL_INVALID_WORK_ITEM_SIZE");
		break;
		case CL_MISALIGNED_SUB_BUFFER_OFFSET:
		  printf(fmtString, "CL_MISALIGNED_SUB_BUFFER_OFFSET");
		break;
		case CL_INVALID_IMAGE_SIZE:
		  printf(fmtString, "CL_INVALID_IMAGE_SIZE");
		break; /*
		case CL_INVALID_IMAGE_FORMAT:
		  printf(fmtString, "CL_INVALID_IMAGE_FORMAT");
		break; */
		case CL_INVALID_HOST_PTR:
		  printf(fmtString, "CL_INVALID_HOST_PTR");
		break;
		case CL_INVALID_IMAGE_FORMAT_DESCRIPTOR:
		  printf(fmtString, "CL_INVALID_IMAGE_FORMAT_DESCRIPTOR");
		break;
		case CL_INVALID_IMAGE_DESCRIPTOR:
		  printf(fmtString, "CL_INVALID_IMAGE_DESCRIPTOR");
		break;;
		case CL_IMAGE_FORMAT_NOT_SUPPORTED:
		  printf(fmtString, "CL_IMAGE_FORMAT_NOT_SUPPORTED");
		break;
		case CL_OUT_OF_RESOURCES:
		  printf(fmtString, "CL_OUT_OF_RESOURCES");
		break;
		case CL_MEM_OBJECT_ALLOCATION_FAILURE:
		  printf(fmtString, "CL_MEM_OBJECT_ALLOCATION_FAILURE");
		break;
		case CL_INVALID_EVENT_WAIT_LIST:
		  printf(fmtString, "CL_INVALID_EVENT_WAIT_LIST");
		break;
		case CL_INVALID_MEM_OBJECT:
		  printf(fmtString, "CL_INVALID_MEM_OBJECT");
		break;
		case CL_OUT_OF_HOST_MEMORY:
		  printf(fmtString, "CL_OUT_OF_HOST_MEMORY");
		break;
		case CL_INVALID_PROGRAM:
		  printf(fmtString, "CL_INVALID_PROGRAM");
		break;
		case CL_INVALID_VALUE:
		  printf(fmtString, "CL_INVALID_VALUE");
		break;
		case CL_BUILD_PROGRAM_FAILURE:
		  printf(fmtString, "CL_BUILD_PROGRAM_FAILURE");
		break;
		default:
		  printf("undocumented eror: %d\n", errCode);
		  break;
	}
	return errCode != CL_SUCCESS;
}
int checkErrorMsg(cl_int errCode, char *msg) {
	if (errCode != CL_SUCCESS) {
		printf("Error in %s: ", msg);
		return checkError(errCode);
	} else {
		return errCode != CL_SUCCESS;
	}
}
